/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.nano.expr;

import net.morilib.awk.nano.io.AwkFiles;
import net.morilib.awk.nano.namespace.AwkNamespace;
import net.morilib.awk.nano.parser.AwkRelop;
import net.morilib.awk.nano.value.AwkValue;

/**
 * 関係演算を表す中間表現です。
 * 
 * @author MORIGUCHI, Yuichiro 2013/03
 */
public class AwkRelationOp extends AwkExpression {

	private AwkExpression e1, e2;
	private AwkRelop.Operator op;

	/**
	 * 中間表現を生成します。
	 * 
	 * @param e1 式1
	 * @param e2 式2
	 * @param op 関係演算の種類
	 */
	public AwkRelationOp(AwkExpression e1, AwkExpression e2,
			AwkRelop.Operator op) {
		this.e1 = e1;
		this.e2 = e2;
		this.op = op;
	}

	/**
	 * 左辺を取得します。
	 */
	public AwkExpression getLeft() {
		return e1;
	}

	/**
	 * 右辺を取得します。
	 */
	public AwkExpression getRight() {
		return e2;
	}

	/* (non-Javadoc)
	 * @see net.morilib.awk.expr.AwkExpression#eval(net.morilib.awk.namespace.AwkNamespace, net.morilib.awk.io.AwkFiles)
	 */
	public AwkValue eval(AwkNamespace ns, AwkFiles o) {
		AwkValue r1 = e1.eval(ns, o), r2 = e2.eval(ns, o);

		switch(op) {
		case EQ:  return AwkValue.equals(r1, r2, ns);
		case NE:  return AwkValue.ne(r1, r2, ns);
		case LT:  return AwkValue.lt(r1, r2, ns);
		case LE:  return AwkValue.le(r1, r2, ns);
		case GT:  return AwkValue.gt(r1, r2, ns);
		case GE:  return AwkValue.ge(r1, r2, ns);
		default:  throw new RuntimeException();
		}
	}

	/* (non-Javadoc)
	 * @see net.morilib.awk.expr.AwkExpression#maybeInputRedirect()
	 */
	public boolean maybeInputRedirect() {
		return op.equals(AwkRelop.Operator.LT);
	}

	/* (non-Javadoc)
	 * @see net.morilib.awk.expr.AwkExpression#maybeOutputRedirect()
	 */
	public boolean maybeOutputRedirect() {
		return op.equals(AwkRelop.Operator.GT);
	}

}
